diff --git a/src/backend/storage/ipc/ipci.c b/src/backend/storage/ipc/ipci.c
index bd75f06047e..cfd952e621e 100644
--- a/src/backend/storage/ipc/ipci.c
+++ b/src/backend/storage/ipc/ipci.c
@@ -133,7 +133,7 @@ CalculateShmemSize(int *num_semaphores)
 	 * memory segment that it uses in the corresponding AnonymousMappings.
 	 * Consider size required from only the main shared memory segment here.
 	 */
-	size = add_size(size, BufferManagerShmemSize());
+	size = add_size(size, BufferManagerShmemSize(true));
 	size = add_size(size, LockManagerShmemSize());
 	size = add_size(size, PredicateLockShmemSize());
 	size = add_size(size, ProcGlobalShmemSize());
@@ -187,10 +187,14 @@ CalculateShmemSize(int *num_semaphores)
 	 * shared memory segment.
 	 */
 	Mappings[MAIN_SHMEM_SEGMENT].shmem_req_size = size;
+	Mappings[MAIN_SHMEM_SEGMENT].shmem_reserved = size;
 
 	/* might as well round it off to a multiple of a typical page size */
 	for (int segment = 0; segment < ANON_MAPPINGS; segment++)
+	{
 		Mappings[segment].shmem_req_size = add_size(Mappings[segment].shmem_req_size, 8192 - (Mappings[segment].shmem_req_size % 8192));
+		Mappings[segment].shmem_reserved = add_size(Mappings[segment].shmem_reserved, 8192 - (Mappings[segment].shmem_reserved % 8192));
+	}
 
 	return size;
 }
@@ -341,7 +345,7 @@ CreateOrAttachShmemStructs(void)
 	CommitTsShmemInit();
 	SUBTRANSShmemInit();
 	MultiXactShmemInit();
-	BufferManagerShmemInit(0);
+	BufferManagerShmemInit();
 
 	/*
 	 * Set up lock manager
diff --git a/src/backend/storage/ipc/procsignal.c b/src/backend/storage/ipc/procsignal.c
index 2160d258fa7..0a173f038a3 100644
--- a/src/backend/storage/ipc/procsignal.c
+++ b/src/backend/storage/ipc/procsignal.c
@@ -657,9 +657,17 @@ ProcessProcSignalBarrier(void)
 					case PROCSIGNAL_BARRIER_SMGRRELEASE:
 						processed = ProcessBarrierSmgrRelease();
 						break;
-					case PROCSIGNAL_BARRIER_SHMEM_RESIZE:
-						processed = ProcessBarrierShmemResize(
-								&ShmemCtrl->Barrier);
+					case PROCSIGNAL_BARRIER_SHBUF_SHRINK:
+						processed = ProcessBarrierShmemShrink();
+						break;
+					case PROCSIGNAL_BARRIER_SHBUF_RESIZE_MAP_AND_MEM:
+						processed = ProcessBarrierShmemResizeMapAndMem();
+						break;
+					case PROCSIGNAL_BARRIER_SHBUF_EXPAND:
+						processed = ProcessBarrierShmemExpand();
+						break;
+					case PROCSIGNAL_BARRIER_SHBUF_RESIZE_FAILED:
+						processed = ProcessBarrierShmemResizeFailed();
 						break;
 				}
 
diff --git a/src/backend/storage/ipc/shmem.c b/src/backend/storage/ipc/shmem.c
index 0f9abf69fd5..9793d27042a 100644
--- a/src/backend/storage/ipc/shmem.c
+++ b/src/backend/storage/ipc/shmem.c
@@ -69,11 +69,19 @@
 #include "funcapi.h"
 #include "miscadmin.h"
 #include "port/pg_numa.h"
+#include "postmaster/bgwriter.h"
+#include "storage/bufmgr.h"
+#include "storage/buf_internals.h"
+#include "storage/ipc.h"
 #include "storage/lwlock.h"
 #include "storage/pg_shmem.h"
+#include "storage/pmsignal.h"
+#include "storage/procsignal.h"
 #include "storage/shmem.h"
 #include "storage/spin.h"
 #include "utils/builtins.h"
+#include "utils/injection_point.h"
+#include "utils/wait_event.h"
 
 static void *ShmemAllocRaw(Size size, Size *allocated_size);
 static void *ShmemAllocRawInSegment(Size size, Size *allocated_size,
@@ -498,28 +506,15 @@ ShmemInitStructInSegment(const char *name, Size size, bool *foundPtr,
 	{
 		/*
 		 * Structure is in the shmem index so someone else has allocated it
-		 * already. Verify the structure's size:
-		 * - If it's the same, we've found the expected structure.
-		 * - If it's different, we're resizing the expected structure.
-		 *
-		 * XXX: There is an implicit assumption this can only happen in
-		 * "resizable" segments, where only one shared structure is allowed.
-		 * This has to be implemented more cleanly. Probably we should implement
-		 * ShmemReallocRawInSegment functionality just to adjust the size
-		 * according to alignment, return the allocated size and update the
-		 * mapping offset.
+		 * already. The size better be the same as the size we are trying to
 		 */
 		if (result->size != size)
 		{
-			Size delta = size - result->size;
-
-			result->size = size;
-			result->allocated_size = size;
-
-			/* Reflect size change in the shared segment */
-			SpinLockAcquire(Segments[shmem_segment].ShmemLock);
-			Segments[shmem_segment].ShmemSegHdr->freeoffset += delta;
-			SpinLockRelease(Segments[shmem_segment].ShmemLock);
+			LWLockRelease(ShmemIndexLock);
+			ereport(ERROR,
+					(errmsg("ShmemIndex entry size is wrong for data structure"
+							" \"%s\": expected %zu, actual %zu",
+							name, size, result->size)));
 		}
 
 		structPtr = result->location;
@@ -556,6 +551,59 @@ ShmemInitStructInSegment(const char *name, Size size, bool *foundPtr,
 	return structPtr;
 }
 
+/*
+ * ShmemUpdateStructInSegment -- Update the size of a structure in shared memory.
+ *
+ * This function updates the size of an existing shared memory structure. It
+ * finds the structure in the shmem index and updates its size information while
+ * preserving the existing memory location.
+ *
+ * Returns: pointer to the existing structure location.
+ */
+void *
+ShmemUpdateStructInSegment(const char *name, Size size, bool *foundPtr,
+						   int shmem_segment)
+{
+	ShmemIndexEnt *result;
+	void	   *structPtr;
+	Size delta;
+
+	LWLockAcquire(ShmemIndexLock, LW_EXCLUSIVE);
+
+	Assert(ShmemIndex);
+
+	/* Look up the structure in the shmem index */
+	result = (ShmemIndexEnt *)
+		hash_search(ShmemIndex, name, HASH_FIND, foundPtr);
+
+	Assert(*foundPtr);
+	Assert(result);
+	Assert(result->shmem_segment == shmem_segment);
+
+	delta = size - result->size;
+	/* Store the existing structure pointer */
+	structPtr = result->location;
+
+	/* Update the size information.
+	   TODO: Ideally we should implement repalloc kind of functionality for shared memory which will return allocated size. */
+	result->size = size;
+	result->allocated_size = size;
+
+	/* Reflect size change in the shared segment */
+	SpinLockAcquire(Segments[shmem_segment].ShmemLock);
+	Segments[shmem_segment].ShmemSegHdr->freeoffset += delta;
+	SpinLockRelease(Segments[shmem_segment].ShmemLock);
+	LWLockRelease(ShmemIndexLock);
+
+	/* Verify the structure is still in the correct segment */
+	Assert(ShmemAddrIsValidInSegment(structPtr, shmem_segment));
+	Assert(structPtr == (void *) CACHELINEALIGN(structPtr));
+
+	return structPtr;
+}
+
+
+
 /*
  * Add two Size values, checking for overflow
  */
@@ -892,3 +940,402 @@ pg_get_shmem_segments(PG_FUNCTION_ARGS)
 	return (Datum) 0;
 }
 
+/*
+ * TODO: The function henceforth are related to buffer manager and better be
+ * placed in buffer manager related file.
+ */
+
+/*
+ * Prepare ShmemCtrl for resizing the shared buffer pool.
+ */
+static void
+MarkBufferResizingStart(int targetNBuffers, int currentNBuffers)
+{
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
+
+	pg_atomic_write_u32(&ShmemCtrl->currentNBuffers, currentNBuffers);
+	pg_atomic_write_u32(&ShmemCtrl->targetNBuffers, targetNBuffers);
+	pg_atomic_write_u32(&ShmemCtrl->activeNBuffers, Min(targetNBuffers, currentNBuffers));
+	pg_atomic_write_u32(&ShmemCtrl->transitNBuffers, currentNBuffers);
+	ShmemCtrl->coordinator = MyProcPid;
+	ShmemCtrl->pmwork_done = false;
+}
+
+/*
+ * Reset ShmemCtrl after resizing the shared buffer pool is done.
+ */
+static void
+MarkBufferResizingEnd(int NBuffers)
+{	
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
+
+	pg_atomic_write_u32(&ShmemCtrl->currentNBuffers, NBuffers);
+	pg_atomic_write_u32(&ShmemCtrl->targetNBuffers, NBuffers);
+	pg_atomic_write_u32(&ShmemCtrl->activeNBuffers, NBuffers);
+	pg_atomic_write_u32(&ShmemCtrl->transitNBuffers, NBuffers);
+	ShmemCtrl->coordinator = -1;
+	ShmemCtrl->pmwork_done = false;
+}
+
+/*
+ * Function which updates the shared buffers according to the current values of
+ * shared_buffers GUCs.
+ *
+ * When resizing the buffer pool is divided into two portions
+ *
+ * - active buffer pool, which is the part of buffer pool which remains active
+ * even during resizing. Its size is given by activeNBuffers. Newly allocated
+ * buffers will have their buffer ids less than activeNBuffers.
+ *
+ * - in-transit buffer pool, which is the part of buffer pool which may be
+ * accessible to some backends but not others. When shrinking the buffer pool
+ * this is the part of buffer pool which will be evicted. When expanding the
+ * buffer pool this is the expanded portion. Its size is given by
+ * transitNBuffers. The backends may see buffer ids upto transitNBuffers.
+ *
+ * Before starting resizing, activeNBuffers = transitNBuffers = NBuffers. And
+ * NewNBuffers is the new size of shared buffer pool.
+ *
+ * In order to synchronize with other running backends, the coordinator sends
+ * following ProcSignalBarriers in the order given below:
+ *
+ * 1. When shrinking the shared buffer pool (with size NBuffers), the coordinator
+ * sends SHBUF_SHRINK ProcSignalBarrier. Every backend sets activeNBuffers =
+ * NewNBuffers to restrict its buffer pool allocations to the new size of the
+ * buffer pool and acknowledges the ProcSignalBarrrier. Once every backend has
+ * acknowledged, the coordinator evicts the buffers in the area being shrunk.
+ * Note that tansitNBuffers is still NBuffers, so the backends may see buffer ids
+ * upto NBuffers from earlier allocations.
+ *
+ * 2. In both cases, when expanding the buffer pool or shrinking the buffer pool,
+ * the coordinator sends SHBUF_RESIZE_MAP_AND_MEM ProcSignalBarrier. Every
+ * backend is expected to adjust their shared memory segment maps (by calling
+ * AnonymousShmemResize()) and validate that their pointers to the shared buffers
+ * structure are valid and have the right size. When shrinking shared buffer pool
+ * transitNBuffers is set to NewNBuffers and the backends should no more see
+ * buffer ids beyond NewNBuffers. When expanding they should also set
+ * transitNBuffers to NewNBuffers to accomodate backends which may accept the
+ * next barrier earlier than the others. After this the backends should
+ * acknowledge the ProcSignalBarrier.
+ *
+ * 3. When expanding the buffer pool, the coordinator sends SHBUF_EXPAND
+ * ProcSignalBarrier. The backends are expected to set activeNBuffers =
+ * NewNBuffers and start allocating buffers from the expanded range.
+ *
+ * Find a better place for this function, also a name if we find this interface
+ * viable.
+ *
+ * TODO: Should this function be in bufmgr.c?
+ *
+ * TODO: Handle the case when the backend executing this function dies or the
+ * query is cancelled.
+ */
+Datum
+pg_resize_shared_buffers(PG_FUNCTION_ARGS)
+{
+	bool result = true;
+	int currentNBuffers = NBuffers;
+	int targetNBuffers = NBuffersPending;
+
+	if (currentNBuffers == targetNBuffers)
+	{
+		elog(LOG, "shared buffers are already at %d, no need to resize", currentNBuffers);
+		PG_RETURN_BOOL(true);
+	}
+
+	if (!pg_atomic_test_set_flag(&ShmemCtrl->resize_in_progress))
+	{
+		elog(LOG, "shared buffer resizing already in progress");
+		PG_RETURN_BOOL(false);
+	}
+
+	MarkBufferResizingStart(targetNBuffers, currentNBuffers);
+	elog(LOG, "resizing shared buffers from %d to %d", currentNBuffers, targetNBuffers);
+
+	INJECTION_POINT("pg-resize-shared-buffers-flag-set", NULL);
+
+	/* Phase 1: SHBUF_SHRINK - Only for shrinking buffer pool */
+	if (targetNBuffers < currentNBuffers)
+	{
+		/*
+		 * Phase 1: Shrinking - send SHBUF_SHRINK barrier
+		 * Every backend sets activeNBuffers = NewNBuffers to restrict 
+		 * buffer pool allocations to the new size
+		 */
+		elog(LOG, "Phase 1: Shrinking buffer pool, restricting allocations to %d buffers", targetNBuffers);
+		
+		WaitForProcSignalBarrier(EmitProcSignalBarrier(PROCSIGNAL_BARRIER_SHBUF_SHRINK));
+		elog(LOG, "all backends acknowledged shrink phase");
+
+		/* Evict buffers in the area being shrunk */
+		elog(LOG, "evicting buffers %u..%u", targetNBuffers + 1, currentNBuffers);
+		if (!EvictExtraBuffers(targetNBuffers, currentNBuffers))
+		{
+			elog(ERROR, "failed to evict extra buffers during shrinking");
+			WaitForProcSignalBarrier(EmitProcSignalBarrier(PROCSIGNAL_BARRIER_SHBUF_RESIZE_FAILED));
+			MarkBufferResizingEnd(currentNBuffers);
+			pg_atomic_clear_flag(&ShmemCtrl->resize_in_progress);
+			Assert(NBuffers == currentNBuffers);
+			NBuffers = pg_atomic_read_u32(&ShmemCtrl->currentNBuffers);
+			PG_RETURN_BOOL(false);
+		}
+
+		/* This backend handles NBuffers itself instead of relying on the barrier
+		 * handler, so that barrier handlers do not interfere with its
+		 * operations. */
+		NBuffers = targetNBuffers;
+	}
+
+	/* Phase 2: SHBUF_RESIZE_MAP_AND_MEM - Both expanding and shrinking */
+	elog(LOG, "Phase 2: Remapping shared memory segments and updating structures");
+	if (!AnonymousShmemResize())
+	{
+		/*
+		 * This should never fail since address map should already be reserved.
+		 * So the failure should be treated as PANIC.
+		 */
+		elog(PANIC, "failed to resize anonymous shared memory");
+	}
+
+	/* When shrinking no backends should see buffers beyond active portion of the
+	 * buffer pool. When expanding, update transitNBuffers so backends can see
+	 * the new range. */
+	pg_atomic_write_u32(&ShmemCtrl->transitNBuffers, targetNBuffers);
+
+	/* Update structure pointers and sizes */
+	BufferManagerShmemResize(currentNBuffers, targetNBuffers);
+
+	/* Request Postmaster to remap and resize. TODO: Handle the case when Postmaster is not able to remap and resize the shared memory structures. */
+	SendPostmasterSignal(PMSIGNAL_SHMEM_RESIZE);
+	elog(LOG, "waiting for the postmaster to finish remapping and resizing the shared buffers");
+	while (!ShmemCtrl->pmwork_done)
+	{
+		if (ConditionVariableTimedSleep(&ShmemCtrl->pm_cv,
+										5000,
+										WAIT_EVENT_PM_BUFFER_RESIZE_WAIT))
+			ereport(LOG,
+					(errmsg("still waiting for the postmaster PID %d to finish resizing buffers",
+							(int) PostmasterPid)));
+	}
+	ConditionVariableCancelSleep();
+	elog(LOG, "postmaster remapped and resized the shared memory");
+
+	WaitForProcSignalBarrier(EmitProcSignalBarrier(PROCSIGNAL_BARRIER_SHBUF_RESIZE_MAP_AND_MEM));
+	elog(LOG, "all backends acknowledged memory remapping and structure updates");
+
+	/* Phase 3: SHBUF_EXPAND - Only for expanding buffer pool */
+	if (targetNBuffers > currentNBuffers)
+	{
+		/*
+		 * Phase 3: Expanding - send SHBUF_EXPAND barrier
+		 * Backends set activeNBuffers = NewNBuffers and start allocating 
+		 * buffers from the expanded range
+		 */
+		elog(LOG, "Phase 3: Expanding buffer pool, enabling allocations up to %d buffers", targetNBuffers);
+		
+		WaitForProcSignalBarrier(EmitProcSignalBarrier(PROCSIGNAL_BARRIER_SHBUF_EXPAND));
+		elog(LOG, "all backends acknowledged expand phase");
+
+		/* This backend handles NBuffers itself instead of relying on the barrier
+		 * handler, so that barrier handlers do not interfere with its
+		 * operations. */
+		NBuffers = targetNBuffers;
+	}
+
+	/*
+	 * Reset buffer resize control area.
+	 */
+	MarkBufferResizingEnd(targetNBuffers);
+
+	pg_atomic_clear_flag(&ShmemCtrl->resize_in_progress);
+
+	elog(LOG, "successfully resized shared buffers to %d", targetNBuffers);
+
+	PG_RETURN_BOOL(result);
+}
+
+bool
+ProcessBarrierShmemShrink(void)
+{
+	int targetNBuffers = pg_atomic_read_u32(&ShmemCtrl->targetNBuffers);
+	int activeNBuffers = pg_atomic_read_u32(&ShmemCtrl->activeNBuffers);
+
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
+
+	/* The work to be done by the coordinator is done in the function which sends the barriers. Hence acknowledge immediately. */
+	if (ShmemCtrl->coordinator == MyProcPid)
+	{
+		elog(LOG, "Phase 1: Coordinator backend %d acknowledging SHBUF_SHRINK barrier immediately", MyProcPid);
+		return true;
+	}
+
+	/*
+	 * Delay adjusting the new active size of buffer pool till this process
+	 * becomes ready to resize buffers.
+	 */
+	if (delay_shmem_resize)
+	{
+		elog(LOG, "Phase 1: Delaying SHBUF_SHRINK barrier - restricting allocations from %d to %d buffers, coordinator is %d",
+			NBuffers, targetNBuffers, ShmemCtrl->coordinator);
+
+		return false;
+	}
+
+	elog(LOG, "Phase 1: Processing SHBUF_SHRINK barrier - restricting allocations from %d to %d buffers, coordinator is %d",
+			NBuffers, targetNBuffers, ShmemCtrl->coordinator);
+
+	if (MyBackendType == B_BG_WRITER)
+	{
+		/*
+		 * Before resuming regular background writer activity, adjust the
+		 * statistics collected so far.
+		 */
+		BgBufferSyncReset(NBuffers, targetNBuffers);
+		/* Reset strategy control to new size */
+		StrategyReset(targetNBuffers);
+	}
+
+	/* Update local knowledge of activeNBuffers  */
+	NBuffers = activeNBuffers;
+
+	return true;
+}
+
+bool
+ProcessBarrierShmemResizeMapAndMem(void)
+{
+	int targetNBuffers = pg_atomic_read_u32(&ShmemCtrl->targetNBuffers);
+#ifdef USE_ASSERT_CHECKING
+	int activeNBuffers = pg_atomic_read_u32(&ShmemCtrl->activeNBuffers);
+	int transitNBuffers = pg_atomic_read_u32(&ShmemCtrl->transitNBuffers);
+#endif /* USE_ASSERT_CHECKING */
+
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
+
+	/* The work to be done by the coordinator is done in the function which sends the barriers. Hence acknowledge immediately. */
+	if (ShmemCtrl->coordinator == MyProcPid)
+	{
+		elog(LOG, "Phase 2: Coordinator backend %d acknowledging SHBUF_RESIZE_MAP_AND_MEM barrier immediately", MyProcPid);
+		return true;
+	}
+
+	/*
+	 * If buffer pool is being shrunk, we are already working with a smaller
+	 * buffer pool, so shrinking address space and shared structures should not
+	 * be a problem. When expanding, expanding the address space and shared
+	 * structures beyond the current boundaries is not going to be a problem
+	 * since we are not accessing that memory yet. So there is no reason to
+	 * delay processing this barrier.
+	 */
+
+	elog(LOG, "Phase 2: Processing SHBUF_RESIZE_MAP_AND_MEM barrier - adjusting memory maps and validating structures, coordinator is %d",
+			ShmemCtrl->coordinator);
+
+	/* 
+	 * NBuffers should already be set to activeNBuffers from Phase 1.
+	 * When shrinking, NBuffers should also be same as transitNBuffers in this phase.
+	 */
+	Assert(NBuffers == activeNBuffers);
+	if (targetNBuffers < pg_atomic_read_u32(&ShmemCtrl->currentNBuffers))
+	{
+		/* Shrinking case - verify NBuffers equals transitNBuffers */
+		Assert(NBuffers == transitNBuffers);
+	}
+
+	/* 
+	 * Address space should already be reserved so resizing should not fail. If
+	 * it fails, the address map of this backend may go out of sync with other
+	 * backends. Hence PANIC.
+	 */
+	if (!AnonymousShmemResize())
+		elog(PANIC, "failed to resize anonymous shared memory in backend %d", MyProcPid);
+
+	elog(LOG, "Backend %d successfully remapped shared memory segments for buffer resize", MyProcPid);
+
+	/* 
+	 * Backends validate that their pointers to shared buffer structures are 
+	 * still valid and have the correct size after memory remapping.
+	 */
+	BufferManagerShmemValidate(targetNBuffers);
+	
+	/* 
+	 * TODO: Save new transitNBuffers value in process local memory, if
+	 * necessary.
+	 */
+	elog(LOG, "Backend %d successfully validated structure pointers after resize", MyProcPid);
+
+	return true;
+}
+
+bool
+ProcessBarrierShmemExpand(void)
+{
+	int targetNBuffers = pg_atomic_read_u32(&ShmemCtrl->targetNBuffers);
+#ifdef USE_ASSERT_CHECKING
+	int transitNBuffers = pg_atomic_read_u32(&ShmemCtrl->transitNBuffers);
+#endif /* USE_ASSERT_CHECKING */
+
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
+
+	/* The work to be done by the coordinator is done in the function which sends the barriers. Hence acknowledge immediately. */
+	if (ShmemCtrl->coordinator == MyProcPid)
+	{
+		elog(LOG, "Phase 3: Coordinator backend %d acknowledging SHBUF_EXPAND barrier immediately", MyProcPid);
+		return true;
+	}
+
+	/*
+	 * Delay adjusting the new active size of buffer pool till this process
+	 * becomes ready to resize buffers.
+	 */
+	if (delay_shmem_resize)
+	{
+		elog(LOG, "Phase 3: delaying SHBUF_EXPAND barrier - enabling allocations up to %d buffers, coordinator is %d",
+				targetNBuffers, ShmemCtrl->coordinator);
+		return false;
+	}
+
+	elog(LOG, "Phase 3: Processing SHBUF_EXPAND barrier - enabling allocations up to %d buffers, coordinator is %d",
+			targetNBuffers, ShmemCtrl->coordinator);
+
+	if (MyBackendType == B_BG_WRITER)
+	{
+		/*
+		 * Adjust background writer statistics for the expanded buffer pool
+		 */
+		BgBufferSyncReset(NBuffers, targetNBuffers);
+		StrategyReset(targetNBuffers);
+	}
+
+	/* Update local knowledge about the size of active buffer pool. */
+	NBuffers = targetNBuffers;
+
+	/* When expanding, NBuffers should be same as transitNBuffers previous phase. */
+	Assert(NBuffers == transitNBuffers);
+
+	return true;
+}
+
+bool
+ProcessBarrierShmemResizeFailed(void)
+{
+	int currentNBuffers = pg_atomic_read_u32(&ShmemCtrl->currentNBuffers);
+	int targetNBuffers = pg_atomic_read_u32(&ShmemCtrl->targetNBuffers);
+
+	Assert(!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress));
+
+	/* The work to be done by the coordinator is done in the function which sends the barriers. Hence acknowledge immediately. */
+	if (ShmemCtrl->coordinator == MyProcPid)
+	{
+		elog(LOG, "Coordinator backend %d acknowledging SHBUF_RESIZE_FAILED barrier immediately", MyProcPid);
+		return true;
+	}
+
+	elog(LOG, "received proc signal indicating failure to resize shared buffers from %d to %d, restoring to %d, coordinator is %d",
+			NBuffers, targetNBuffers, currentNBuffers, ShmemCtrl->coordinator);
+
+	/* Restore NBuffers to the original value */
+	NBuffers = currentNBuffers;
+
+	return true;
+}
diff --git a/src/backend/tcop/postgres.c b/src/backend/tcop/postgres.c
index ee9f308379c..b43f1408855 100644
--- a/src/backend/tcop/postgres.c
+++ b/src/backend/tcop/postgres.c
@@ -4129,6 +4129,9 @@ PostgresSingleUserMain(int argc, char *argv[],
 	/* Initialize size of fast-path lock cache. */
 	InitializeFastPathLocks();
 
+	/* Initialize MaxNBuffers for buffer pool resizing. */
+	InitializeMaxNBuffers();
+
 	/*
 	 * Give preloaded libraries a chance to request additional shared memory.
 	 */
@@ -4319,14 +4322,12 @@ PostgresMain(const char *dbname, const char *username)
 	 */
 	BeginReportingGUCOptions();
 
-	/* Verify the shared barrier, if it's still active: join and wait. */
-	WaitOnShmemBarrier();
-
 	/*
-	 * After waiting on the barrier above we guaranteed to have NSharedBuffers
-	 * broadcasted, so we can use it in the function below.
+	 * TODO: The new backend should fetch the shared buffers status. If the
+	 * resizing is going on, it should bring itself upto speed with it. If not,
+	 * simply fetch the latest pointers are sizes. Is this the right place to do
+	 * that?
 	 */
-	AdjustShmemSize();
 
 	/*
 	 * Also set up handler to log session end; we have to wait till now to be
diff --git a/src/backend/utils/init/globals.c b/src/backend/utils/init/globals.c
index 90d3feb547c..894a04caf0f 100644
--- a/src/backend/utils/init/globals.c
+++ b/src/backend/utils/init/globals.c
@@ -139,8 +139,10 @@ int			max_parallel_maintenance_workers = 2;
  * MaxBackends is computed by PostmasterMain after modules have had a chance to
  * register background workers.
  */
-int			NBuffers = 16384;
-int			MaxAvailableMemory = 524288;
+int			NBuffers = 0;
+int			NBuffersPending = 16384;
+bool finalMaxNBuffers = false;
+int			MaxNBuffers = 0;
 int			MaxConnections = 100;
 int			max_worker_processes = 8;
 int			max_parallel_workers = 8;
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 641e535a73c..e0401fb6477 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -599,6 +599,38 @@ InitializeFastPathLocks(void)
 		   pg_nextpower2_32(FastPathLockGroupsPerBackend));
 }
 
+/*
+ * Initialize MaxNBuffers variable with validation.
+ *
+ * This must be called after GUCs have been loaded but before shared memory size
+ * is determined.
+ *
+ * Since MaxNBuffers limits the size of the buffer pool, it must be at least as
+ * much as NBuffersPending. If MaxNBuffers is 0 (default), set it to
+ * NBuffersPending. Otherwise, validate that MaxNBuffers is not less than
+ * NBuffersPending.
+ */
+void
+InitializeMaxNBuffers(void)
+{
+	if (MaxNBuffers == 0)  /* default/boot value */
+		MaxNBuffers = NBuffersPending;
+	else
+	{
+		if (MaxNBuffers < NBuffersPending)
+		{
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					 errmsg("max_shared_buffers (%d) cannot be less than current shared_buffers (%d)",
+							MaxNBuffers, NBuffersPending),
+					 errhint("Increase max_shared_buffers or decrease shared_buffers.")));
+		}
+	}
+	
+	Assert(!finalMaxNBuffers);
+	finalMaxNBuffers = true;
+}
+
 /*
  * Early initialization of a backend (either standalone or under postmaster).
  * This happens even before InitPostgres.
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index 8794e26ef1d..71a09a65182 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -2731,7 +2731,7 @@ convert_to_base_unit(double value, const char *unit,
  * the value without loss.  For example, if the base unit is GUC_UNIT_KB, 1024
  * is converted to 1 MB, but 1025 is represented as 1025 kB.
  */
-static void
+void
 convert_int_from_base_unit(int64 base_value, int base_unit,
 						   int64 *value, const char **unit)
 {
diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index a0c37a7749e..efe3d3c73ff 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -172,8 +172,11 @@ extern PGDLLIMPORT bool ExitOnAnyError;
 extern PGDLLIMPORT char *DataDir;
 extern PGDLLIMPORT int data_directory_mode;
 
+/* TODO: This is no more a GUC variable; should be moved somewhere else. */
 extern PGDLLIMPORT int NBuffers;
-extern PGDLLIMPORT int MaxAvailableMemory;
+extern PGDLLIMPORT int NBuffersPending;
+extern PGDLLIMPORT bool finalMaxNBuffers;
+extern PGDLLIMPORT int MaxNBuffers;
 extern PGDLLIMPORT int MaxBackends;
 extern PGDLLIMPORT int MaxConnections;
 extern PGDLLIMPORT int max_worker_processes;
@@ -502,6 +505,7 @@ extern PGDLLIMPORT ProcessingMode Mode;
 extern void pg_split_opts(char **argv, int *argcp, const char *optstr);
 extern void InitializeMaxBackends(void);
 extern void InitializeFastPathLocks(void);
+extern void InitializeMaxNBuffers(void);
 extern void InitPostgres(const char *in_dbname, Oid dboid,
 						 const char *username, Oid useroid,
 						 bits32 flags,
diff --git a/src/include/storage/buf_internals.h b/src/include/storage/buf_internals.h
index 20bea8132fd..bbb7a225216 100644
--- a/src/include/storage/buf_internals.h
+++ b/src/include/storage/buf_internals.h
@@ -447,7 +447,7 @@ extern void StrategyNotifyBgWriter(int bgwprocno);
 
 extern Size StrategyShmemSize(void);
 extern void StrategyInitialize(bool init);
-extern void StrategyReInitialize(int FirstBufferToInit);
+extern void StrategyReset(int activeNBuffers);
 
 /* buf_table.c */
 extern Size BufTableShmemSize(int size);
diff --git a/src/include/storage/bufmgr.h b/src/include/storage/bufmgr.h
index 74e226269af..6866d09dc22 100644
--- a/src/include/storage/bufmgr.h
+++ b/src/include/storage/bufmgr.h
@@ -20,6 +20,7 @@
 #include "storage/buf.h"
 #include "storage/bufpage.h"
 #include "storage/relfilelocator.h"
+#include "utils/guc.h"
 #include "utils/relcache.h"
 #include "utils/snapmgr.h"
 
@@ -151,6 +152,7 @@ typedef struct WritebackContext WritebackContext;
 
 /* in globals.c ... this duplicates miscadmin.h */
 extern PGDLLIMPORT int NBuffers;
+extern PGDLLIMPORT int NBuffersPending;
 
 /* in bufmgr.c */
 extern PGDLLIMPORT bool zero_damaged_pages;
@@ -197,6 +199,11 @@ extern PGDLLIMPORT int32 *LocalRefCount;
 #define BUFFER_LOCK_SHARE		1
 #define BUFFER_LOCK_EXCLUSIVE	2
 
+/*
+ * prototypes for functions in buf_init.c
+ */
+extern const char *show_shared_buffers(void);
+extern bool check_shared_buffers(int *newval, void **extra, GucSource source);
 
 /*
  * prototypes for functions in bufmgr.c
@@ -300,7 +307,7 @@ extern bool IsBufferCleanupOK(Buffer buffer);
 extern bool HoldingBufferPinThatDelaysRecovery(void);
 
 extern bool BgBufferSync(WritebackContext *wb_context);
-extern void BgBufferSyncReset(int NBuffersOld, int NBuffersNew);
+extern void BgBufferSyncReset(int currentNBuffers, int targetNBuffers);
 
 extern uint32 GetPinLimit(void);
 extern uint32 GetLocalPinLimit(void);
@@ -317,11 +324,13 @@ extern void EvictRelUnpinnedBuffers(Relation rel,
 									int32 *buffers_evicted,
 									int32 *buffers_flushed,
 									int32 *buffers_skipped);
-extern bool EvictExtraBuffers(int fromBuf, int toBuf);
+extern bool EvictExtraBuffers(int targetNBuffers, int currentNBuffers);
 
 /* in buf_init.c */
-extern void BufferManagerShmemInit(int);
-extern Size BufferManagerShmemSize(void);
+extern void BufferManagerShmemInit(void);
+extern Size BufferManagerShmemSize(bool set_reserved);
+extern void BufferManagerShmemResize(int currentNBuffers, int targetNBuffers);
+extern void BufferManagerShmemValidate(int targetNBuffers);
 
 /* in localbuf.c */
 extern void AtProcExit_LocalBuffers(void);
diff --git a/src/include/storage/ipc.h b/src/include/storage/ipc.h
index 6e7b0abb625..10e74b34813 100644
--- a/src/include/storage/ipc.h
+++ b/src/include/storage/ipc.h
@@ -64,7 +64,6 @@ typedef void (*shmem_startup_hook_type) (void);
 /* ipc.c */
 extern PGDLLIMPORT bool proc_exit_inprogress;
 extern PGDLLIMPORT bool shmem_exit_inprogress;
-extern PGDLLIMPORT volatile bool pending_pm_shmem_resize;
 extern PGDLLIMPORT volatile bool delay_shmem_resize;
 
 pg_noreturn extern void proc_exit(int code);
